//==============================================================================
// I𕶎J
//==============================================================================
function openSelected() {
	var str = getSelectedText();
	if (str){
		//URLJ
		urlexOpenURL(str, nsPreferences.getBoolPref("urlex.active.select", false));
	}
}
//==============================================================================
// Nbv{[h̕񂩂^uJ
//==============================================================================
function openClipToTab(){
	//Nbv{[hIuWFNg擾
	var clip = Components.classes["@mozilla.org/widget/clipboard;1"].createInstance(Components.interfaces.nsIClipboard);
	if (!clip) return false;

	//]IuWFNg擾
	var trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
	if (!trans) return false;
	
	//t[o[]IuWFNgɒǉ
	trans.addDataFlavor("text/unicode");
	
	//Nbv{[h̃f[^]IuWFNgɎ擾
	clip.getData(trans, clip.kGlobalClipboard);

	//f[^ƃf[^̒i^sȂ̂Object^gj
	var str = new Object();
	var strLength = new Object();

	//]IuWFNgf[^
	trans.getTransferData("text/unicode", str, strLength);

	//JavaScript̕ɖ߂
	if (str) str = str.value.QueryInterface(Components.interfaces.nsISupportsString);
	if (str) var pastetext = str.data.substring(0, strLength.value / 2);
	
	//URLJ
	urlexOpenURL(pastetext, nsPreferences.getBoolPref("urlex.active.clip", false));
}
//==============================================================================
// URL𕪉肵ĊJ
//==============================================================================
function urlexOpenURL(urlstr, isActive){
	var url_array = urlstr.split("\n");
	
	for (var i = 0; i < url_array.length; i++){
		var str = urlexFixedURL(url_array[i]);
		if (str){
			if (isActive){
				getBrowser().selectedTab = getBrowser().addTab(str);
				isActive = false;
			}else{
				getBrowser().addTab(str);
			}
		}
	}
}
//==============================================================================
// URL𐮂
//==============================================================================
function urlexFixedURL(src){
	//Sppi͈ꎞۗj
	
	//OXy[X
	//ttp://`tp://`p://`://`̑΍i://`͎⊮Ă݂ǈꉞj
	//ime.nu΍
	return trim(src).replace(/^ttp:\/\/|^tp:\/\/|^p:\/\/|^:\/\//g, "http:\/\/").replace(/^ttps:\/\/|^tps:\/\/|^ps:\/\/|^s:\/\//g, "https:\/\/").replace("ime.nu/", "").replace("http://http://", "http://");
}
//==============================================================================
// I𒆂̕Ԃiꉞj
//==============================================================================
function getSelectedText(){
	try{
		var focusedWindow = document.commandDispatcher.focusedWindow;
		if (!focusedWindow || focusedWindow == window)
			focusedWindow = window._content;
		return focusedWindow.getSelection().toString();
	}catch(e){
		return "";
	}
}
//==============================================================================
// Ő󔒁Es
//==============================================================================
function trim(str){
	return str.replace(/^\s+|\s+$/g, "");
}
//==============================================================================
// SppϊiȂKj
// ̂Ƃ떢gp
//==============================================================================
function convertZen2Han(src){
	//Ƃ肠ȂH
	var from = "`abcdefghijklmnopqrstuvwxy|O`^H{FDC@";
	var to = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ-=^~/?+:.,% ";
	var str = "";

	for (var i = 0; i < src.length; i++){
		var c = src.charAt(i);
		var j = from.indexOf(c, 0);
		if (j >= 0){
			str += to.charAt(j);
		}else{
			str += c;
		}
	}
	return str;
}
//==============================================================================
// IĂȂɃj[ڂ
//==============================================================================
function urlexMenuItemVisible(){
	if (gContextMenu){
		var urlexVisible = gContextMenu.isTextSelected;
		var menuItem = document.getElementById("urlexOpenSelected");
		if (menuItem)
			menuItem.hidden = !urlexVisible;
	}
}
//==============================================================================
// ̂o^
//==============================================================================
function urlexInit(){
	var menu = document.getElementById("contentAreaContextMenu");
	menu.addEventListener("popupshowing", urlexMenuItemVisible, false);
}
//==============================================================================
// Ɂ̂ǂݍݎs
//==============================================================================
window.addEventListener("load", urlexInit, false);
